#include  <windows.h>

#include  "Pack.h"


#define SIZE_BITMAP_CPC     0x4000


static int Matches[ 256 ];
static int MachTable[ 256 ][ SEEKBACK ];

static BYTE BufOut[ MAX_BUF ];
static BYTE BufIn[ MAX_BUF ];


static int Depack( BYTE * InBuf, BYTE * OutBuf )
{
    BYTE a, DepackBits = 0;
    int Bit, InBytes = 0, Longueur, Delta, OutBytes = 0;

    for ( ;; )
        {
        Bit = DepackBits & 1;
        DepackBits >>= 1;
        if ( !DepackBits )
            {
            DepackBits = InBuf[ InBytes++ ];
            Bit = DepackBits & 1;
            DepackBits >>= 1;
            DepackBits |= 0x80;
            }
        if ( ! Bit )
            OutBuf[ OutBytes++ ] = InBuf[ InBytes++ ];
        else
            {
            if ( ! InBuf[ InBytes ] )
                break; /* EOF */

            a = InBuf[ InBytes ];
            if ( a & 0x80 )
                {
                Longueur = 3 + ( ( InBuf[ InBytes ] >> 4 ) & 7 );
                Delta = ( InBuf[ InBytes++ ] & 15 ) << 8;
                Delta |= InBuf[ InBytes++ ];
                Delta++;
                }
            else
                if ( a & 0x40 )
                    {
                    Longueur = 2;
                    Delta = InBuf[ InBytes++ ] & 0x3f;
                    Delta++;
                    }
                else
                    if ( a & 0x20 )
                        {
                        Longueur = 2 + ( InBuf[ InBytes++ ] & 31 );
                        Delta = InBuf[ InBytes++ ];
                        Delta++;
                        }
                    else
                        if ( a & 0x10 )
                            {
                            Delta = ( InBuf[ InBytes++ ] & 15 ) << 8;
                            Delta |= InBuf[ InBytes++ ];
                            Longueur = InBuf[ InBytes++ ] + 1;
                            Delta++;
                            }
                        else
                            {
                            if ( InBuf[ InBytes ] == 15 )
                                {
                                Longueur = Delta = InBuf[ InBytes+1 ] + 1;
                                InBytes += 2;
                                }
                            else
                                {
                                if ( InBuf[ InBytes ] > 1 )
                                    Longueur = Delta = InBuf[ InBytes ];
                                else
                                    Longueur = Delta = 256;

                                InBytes++;
                                }
                            }
            for ( ; Longueur--; )
                {
                OutBuf[ OutBytes ] = OutBuf[ OutBytes - Delta ];
                OutBytes++;
                }
            }
        }
    return( InBytes );
}


static int Pack( int Longueur )
{
    BYTE CodeBuffer[ 24 ];
    BYTE Bits = 0;
    int Count = 0, BitCount = 0, CodeCount = 0;
    int MachTableStart = 0, MatchTableEnd = 0, OldMatchTableStart;
    int c, Taille = 0;

    memset( Matches, 0, sizeof( Matches ) );
    for( ;; )
        {
        for ( c = MatchTableEnd; c < Count; c++ )
            {
            int b = BufIn[ c ];
            MachTable[ b ][ Matches[ b ] ] = c;
            Matches[ b ]++;
            }
        MatchTableEnd = Count;

        if ( Count >= 2 )
            {
            int StLen = 0;
            int StPos = 0;
            int StLen2 = 0;
            int bb = BufIn[ Count ];
            for ( c = Matches[ bb ] - 1; c >= 0; c-- )
                {
                int start = MachTable[ bb ][ c ];
                int end = start + MAXSTRING;
                if ( end > Count )
                    end = Count;

                if ( end - start >= StLen )
                    {
                    int max = end - start;
                    int d;

                    for ( d = 1; d < max; d++ )
                        if ( BufIn[ start+d ] != BufIn[ Count+d ] ) 
                            break;

                    if ( ( d >= 2 ) && ( d > StLen ) )
                        {
                        StLen = d;
                        StPos = Count - start;
                        }
                    if ( ( d == StLen ) && ( Count - start < StPos ) )
                        StPos = Count - start;
                    }

                if ( ( StLen == MAXSTRING ) && ( StPos == StLen ) ) 
                    break;
                }
            if ( Count+1 < Longueur )
                {
                bb = BufIn[ Count + 1 ];
                for ( c = Matches[ bb ] - 1; c >= 0; c-- )
                    {
                    int start = MachTable[ bb ][ c ];
                    int end = start + MAXSTRING;
                    if ( end > Count+1 ) end = Count+1;

                    if ( end-start >= StLen2 )
                        {
                        int max = end - start;
                        int d;

                        for ( d = 1; d < max; d++ )
                            if ( BufIn[ start+d ] != BufIn[ Count+d+1 ] )
                                break;

                        if ( ( d >= 2 ) && ( d >= StLen2 ) )
                            StLen2 = d;
                        }
                    if ( StLen2 == MAXSTRING )
                        break;
                    }
                if ( StLen2 - 1 > StLen )
                    StLen = 0;
                }

            if ( StLen > 1 )
                {
                if ( ( StLen == 2 ) && ( StPos >= 256 ) )
                    {
                    CodeBuffer[ CodeCount++ ] = BufIn[ Count++ ];
                    BitCount++;
                    }
                else
                    {
                    if ( StPos == StLen )
                        {
                        if ( StLen == MAXSTRING )
                            CodeBuffer[ CodeCount++ ] = 0x1;
                        else
                            {
                            if ( StLen <= 14 )
                                CodeBuffer[ CodeCount++ ] = ( BYTE )StLen;
                            else
                                {
                                CodeBuffer[ CodeCount++ ] = 0x0F;
                                CodeBuffer[ CodeCount++ ] = ( BYTE )( StLen - 1 );
                                }
                            }
                        }
                    else
                        {
                        if ( ( StLen == 2 ) && ( StPos < 65 ) )
                            CodeBuffer[ CodeCount++ ] = ( BYTE )( 0x40 + StPos - 1 );
                        else
                            {
                            if ( ( StLen <= 33 ) && ( StPos < 257 ) )
                                {
                                CodeBuffer[ CodeCount++ ] = ( BYTE )( 0x20 + StLen - 2 );
                                CodeBuffer[ CodeCount++ ] = ( BYTE )( StPos - 1 );
                                }
                            else
                                {
                                if ( ( StLen >= 3 ) && ( StLen <= 10 ) )
                                    {
                                    CodeBuffer[ CodeCount++ ] = ( BYTE )( 0x80 + ( ( StLen - 3 ) << 4 ) + ( ( StPos - 1 ) >> 8 ) );
                                    CodeBuffer[ CodeCount++ ] = ( BYTE )( StPos - 1 );
                                    }
                                else
                                    {
                                    CodeBuffer[ CodeCount++ ] = ( BYTE )( 0x10 + ( ( StPos - 1 ) >> 8 ) );
                                    CodeBuffer[ CodeCount++ ] = ( BYTE )( StPos - 1 );
                                    CodeBuffer[ CodeCount++ ] = ( BYTE )( StLen - 1 );
                                    }
                                }
                            }
                        }
                    Bits |= 1 << BitCount;
                    BitCount++;
                    Count += StLen;
                    }
                }
            else
                {
                CodeBuffer[ CodeCount++ ] = BufIn[ Count++ ];
                BitCount++;
                }
            }
        else
            {
            CodeBuffer[ CodeCount++ ] = BufIn[ Count++ ];
            BitCount++;
            }
        if ( BitCount == 8 )
            {
            BufOut[ Taille++ ] = Bits;
            memcpy( &BufOut[ Taille ], CodeBuffer, CodeCount );
            Taille += CodeCount;
            BitCount = CodeCount = 0;
            Bits = 0;
            }
        if ( Count >= Longueur )
            break;

        OldMatchTableStart = MachTableStart;
        MachTableStart = Count - SEEKBACK;
        if ( MachTableStart < 0 )
            MachTableStart = 0;

        for ( c = OldMatchTableStart; c < MachTableStart; c++ )
            {
            int b = BufIn[ c ];
            int d;
            for ( d = 0; d < Matches[ b ]; d++ )
                if ( MachTable[ b ][ d ] >= MachTableStart )
                    {
                    memmove( &MachTable[ b ][ 0 ]
                           , &MachTable[ b ][ d ]
                           , ( Matches[ b ] - d ) * sizeof( int )
                           );
                    break;
                    }

            Matches[ b ] -= d;
            }
        }
    CodeBuffer[ CodeCount++ ] = 0;
    Bits |= 1 << BitCount;
    BufOut[ Taille++ ] = Bits;
    memcpy( &BufOut[ Taille ], CodeBuffer, CodeCount );
    Taille += CodeCount;
    return( Taille );
}


static void ConvertBuffScreen( BYTE xDeb
                             , BYTE yDeb
                             , BYTE xFin
                             , BYTE yFin
                             , BYTE * Adr
                             , int * Length
                             )
{
    int l, adr = 0, PosReel = 0;
    int NbOctets = xFin - xDeb + 1;
    BYTE * BLigne = ( BYTE * )malloc( SIZE_BITMAP_CPC );
    if ( BLigne )
        {
        * Length = 0;
        for ( l = 0; l < 200; l++ )
            {
            if ( l >= yDeb && l <= yFin )
                {
                memcpy( &BLigne[ PosReel ], &Adr[ adr + xDeb ], NbOctets );
                PosReel += NbOctets;
                * Length += NbOctets;
                }
            adr += 0x800;
            if ( adr > 0x3FFF )
                adr = adr - 0x3FB0;
            }
        memcpy( BufIn, BLigne, * Length );
        free( BLigne );
        }
}


//
// Dtermine les coordonnes d'un objet affich  l'cran
//
static void FindBuffScreen( BYTE * AdrScr
                          , BYTE * xDeb
                          , BYTE * yDeb
                          , BYTE * xFin
                          , BYTE * yFin
                          )
{
    BYTE l, oct;
    int adr = 0;

    * xFin = 0;
    * xDeb = 79;
    * yDeb = 199;
    * yFin = 0;
    for ( l = 0; l < 200; l++ )
        {
        for ( oct = 0; oct < 80; oct++ )
            {
            if ( AdrScr[ adr + oct ] )
                {
                if ( * xDeb > oct )
                    * xDeb = oct;

                if ( * xFin < oct )
                    * xFin = oct;

                if ( * yDeb > l )
                    * yDeb = l;

                if ( * yFin < l )
                    * yFin = l;
                }
            }
        adr += 0x800;
        if ( adr > 0x3FFF )
            adr = adr - 0x3FB0;
        }
}


int PackScreen( BYTE * AdrSrc, BYTE * AdrDest )
{
    int Longueur, lpack;

    ConvertBuffScreen( 0, 0, 79, 199, AdrSrc, &Longueur );
    lpack = Pack( Longueur );
    if ( AdrDest )
        memcpy( AdrDest, BufOut, lpack );

    return( lpack );
}


int PackWindow( BYTE xDeb
              , BYTE yDeb
              , BYTE xFin
              , BYTE yFin
              , BYTE * AdrSrc
              , BYTE * AdrDest
              )
{
    int Longueur, lpack;

    ConvertBuffScreen( xDeb, yDeb, xFin, yFin, AdrSrc, &Longueur );
    lpack = Pack( Longueur );
    * AdrDest++ = xDeb;
    * AdrDest++ = yDeb;
    * AdrDest++ = xFin;
    * AdrDest++ = yFin;
    memcpy( AdrDest, BufOut, lpack );
    return( lpack + 4 );
}


int PackWinDC( BYTE * AdrSrc, BYTE * AdrDest )
{
    int Longueur, lpack;
    BYTE xDeb, yDeb, xFin, yFin;

    FindBuffScreen( AdrSrc, &xDeb, &yDeb, &xFin, &yFin );
    ConvertBuffScreen( xDeb, yDeb, xFin, yFin, AdrSrc, &Longueur );
    lpack = Pack( Longueur ) + 4;
    * AdrDest++ = xDeb;
    * AdrDest++ = yDeb;
    * AdrDest++ = xFin;
    * AdrDest++ = yFin;
    memcpy( AdrDest, BufOut, lpack );
    return( lpack + 4 );
}


int PackBuffer( BYTE * AdrSrc, int Longueur, BYTE * AdrDest )
{
    int lpack;

    memcpy( BufIn, AdrSrc, Longueur );
    lpack = Pack( Longueur );
    if ( AdrDest )
        memcpy( AdrDest, BufOut, lpack );

    return( lpack );
}


BYTE * GetPackBuff( void )
{
    return( BufOut );
}


int DepackBuffer( BYTE * AdrSrc, BYTE * AdrDest )
{
    return( Depack( AdrSrc, AdrDest ) );
}


int DepackScreen( BYTE * AdrSrc, BYTE * AdrDest )
{
    int Longueur, l, AdrCPC = 0, AdrHost = 0;

    Longueur = Depack( AdrSrc, BufOut );
    for ( l = 0; l < 200; l++ )
        {
        memcpy( &AdrDest[ AdrCPC ], &BufOut[ AdrHost ], 80 );
        AdrHost += 80;
        AdrCPC += 0x800;
        if ( AdrCPC > 0x3FFF )
            AdrCPC = AdrCPC - 0x3FB0;
        }
    return( 0 );
}


int DepackWindow( BYTE * AdrSrc, BYTE * AdrDest )
{
    int Longueur, l, AdrCPC = 0, AdrHost = 0;
    BYTE xDeb, yDeb, xFin, yFin, NbX;

    xDeb = * AdrSrc++;
    yDeb = * AdrSrc++;
    xFin = * AdrSrc++;
    yFin = * AdrSrc++;
    NbX = ( BYTE )( xFin - xDeb + 1 );
    Longueur = Depack( AdrSrc, BufOut );
    for ( l = 0; l < 200; l++ )
        {
        if ( l >= yDeb && l <= yFin )
            {
            memcpy( &AdrDest[ AdrCPC + xDeb ]
                  , &BufOut[ AdrHost ]
                  , NbX
                  );
            AdrHost += NbX;
            }
        AdrCPC += 0x800;
        if ( AdrCPC > 0x3FFF )
            AdrCPC = AdrCPC - 0x3FB0;
        }
    return( 0 );
}
